Index: branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecCu.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecCu.cpp	(revision 12)
@@ -49,8 +49,8 @@
   m_ppcYuvReco    = NULL;
   m_ppcYuvResPred = NULL;
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SKIP
   m_ppcYuvAvail   = NULL;
 #endif
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
   m_ppcYuvSynth   = NULL;
 #endif
@@ -81,8 +81,8 @@
   m_ppcYuvReco    = new TComYuv*    [m_uiMaxDepth-1];
   m_ppcYuvResPred = new TComYuv*    [m_uiMaxDepth-1];
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SKIP
   m_ppcYuvAvail   = new TComYuv*    [m_uiMaxDepth-1];
 #endif
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
   m_ppcYuvSynth   = new TComYuv*    [m_uiMaxDepth-1];
 #endif
@@ -99,8 +99,8 @@
     m_ppcYuvReco   [ui] = new TComYuv;    m_ppcYuvReco   [ui]->create( uiWidth, uiHeight );
     m_ppcYuvResPred[ui] = new TComYuv;    m_ppcYuvResPred[ui]->create( uiWidth, uiHeight );
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SKIP
     m_ppcYuvAvail  [ui] = new TComYuv;    m_ppcYuvAvail  [ui]->create( uiWidth, uiHeight );
 #endif
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
     m_ppcYuvSynth  [ui] = new TComYuv;    m_ppcYuvSynth  [ui]->create( uiWidth, uiHeight );
 #endif
@@ -125,8 +125,8 @@
     m_ppcYuvReco   [ui]->destroy(); delete m_ppcYuvReco   [ui]; m_ppcYuvReco   [ui] = NULL;
     m_ppcYuvResPred[ui]->destroy(); delete m_ppcYuvResPred[ui]; m_ppcYuvResPred[ui] = NULL;
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SKIP
     m_ppcYuvAvail  [ui]->destroy(); delete m_ppcYuvAvail  [ui]; m_ppcYuvAvail  [ui] = NULL;
 #endif
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
     m_ppcYuvSynth  [ui]->destroy(); delete m_ppcYuvSynth  [ui]; m_ppcYuvSynth  [ui] = NULL;
 #endif
@@ -137,8 +137,8 @@
   delete [] m_ppcYuvReco;    m_ppcYuvReco    = NULL;
   delete [] m_ppcYuvResPred; m_ppcYuvResPred = NULL;
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SKIP
   delete [] m_ppcYuvAvail;   m_ppcYuvAvail   = NULL;
 #endif
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
   delete [] m_ppcYuvSynth;   m_ppcYuvSynth   = NULL;
 #endif
@@ -217,5 +217,5 @@
   TComPic* pcPic = pcCU->getPic();
 
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+#if POZNAN_CU_SKIP
   Bool bWholeCUCanBeSynthesized = false;
   Bool bOneSubCUCanNotBeSynthesied = false;
@@ -267,5 +267,5 @@
   if( ( uiRPelX < pcCU->getSlice()->getSPS()->getWidth() ) && ( uiBPelY < pcCU->getSlice()->getSPS()->getHeight() ) )
   {
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+#if POZNAN_CU_SKIP
     if(bOneSubCUCanNotBeSynthesied && (uiDepth < g_uiMaxCUDepth - g_uiAddCUDepth )) // KUBA SYNTH check if CU has 3 synthesied subCU - no split flag is send in that case and CU split is assumed
     {
@@ -446,8 +446,8 @@
 {
   TComPic* pcPic = pcCU->getPic();
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
   if(pcPic->getPicYuvSynth())  m_ppcYuvSynth[uiDepth]->copyFromPicYuv( pcPic->getPicYuvSynth(), pcCU->getAddr(), uiAbsPartIdx );
 #endif
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SKIP
   if(pcPic->getPicYuvAvail())  m_ppcYuvAvail[uiDepth]->copyFromPicYuv( pcPic->getPicYuvAvail(), pcCU->getAddr(), uiAbsPartIdx );
 #endif
@@ -496,12 +496,9 @@
       xReconIntraQT( m_ppcCU[uiDepth], uiAbsPartIdx, uiDepth );
       break;
-#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU
+#if POZNAN_CU_SKIP
     case MODE_SYNTH:
     //  break;
-#if POZNAN_FILL_OCCLUDED_CU_WITH_SYNTHESIS
       m_ppcYuvReco[uiDepth]->copyFromPicYuv(pcPic->getPicYuvSynth(), pcCU->getAddr(), uiAbsPartIdx);
-#else
-      m_ppcYuvReco[uiDepth]->copyFromPicYuv(pcPic->getPicYuvAvail(), pcCU->getAddr(), uiAbsPartIdx); //Poprawiæ
-#endif
+      //m_ppcYuvReco[uiDepth]->copyFromPicYuv(pcPic->getPicYuvAvail(), pcCU->getAddr(), uiAbsPartIdx); //Poprawiæ
       //m_ppcYuvReco[uiDepth]->clear();
       break;
@@ -581,5 +578,9 @@
     m_pcPrediction->predIntraLumaAng( pcPattern, pcCU->getLumaIntraDir(uiPartIdx), pPred, uiStride, uiWidth, uiHeight, pcCU, bAboveAvail, bLeftAvail );
     
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+    m_pcTrQuant->setQPforQuant( pcCU->getQP(uiPartIdx) + pcCU->getQpOffsetForTextCU(uiPartIdx, true), !pcCU->getSlice()->getDepth(), pcCU->getSlice()->getSliceType(), TEXT_LUMA );
+#else
     m_pcTrQuant->setQPforQuant( pcCU->getQP(uiPartIdx), !pcCU->getSlice()->getDepth(), pcCU->getSlice()->getSliceType(), TEXT_LUMA );
+#endif
 #if INTRA_DST_TYPE_7
   m_pcTrQuant->invtransformNxN(TEXT_LUMA, pcCU->getLumaIntraDir(uiPartIdx), pResi, uiStride, pCoeff, uiWidth, uiHeight );
@@ -778,5 +779,9 @@
   }
   //===== inverse transform =====
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+    m_pcTrQuant->setQPforQuant( pcCU->getQP(0) + pcCU->getQpOffsetForTextCU(uiAbsPartIdx, true), !pcCU->getSlice()->getDepth(), pcCU->getSlice()->getSliceType(), TEXT_LUMA );
+#else
   m_pcTrQuant->setQPforQuant  ( pcCU->getQP(0), !pcCU->getSlice()->getDepth(), pcCU->getSlice()->getSliceType(), TEXT_LUMA );
+#endif
 #if INTRA_DST_TYPE_7
   m_pcTrQuant->invtransformNxN( TEXT_LUMA, pcCU->getLumaIntraDir( uiAbsPartIdx ), piResi, uiStride, pcCoeff, uiWidth, uiHeight );
@@ -885,5 +890,9 @@
 
   //===== inverse transform =====
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  m_pcTrQuant->setQPforQuant  ( pcCU->getQP(0) + pcCU->getQpOffsetForTextCU(uiAbsPartIdx, true), !pcCU->getSlice()->getDepth(), pcCU->getSlice()->getSliceType(), eText );
+#else
   m_pcTrQuant->setQPforQuant  ( pcCU->getQP(0), !pcCU->getSlice()->getDepth(), pcCU->getSlice()->getSliceType(), eText );
+#endif
 #if INTRA_DST_TYPE_7 
   m_pcTrQuant->invtransformNxN( eText, REG_DCT, piResi, uiStride, pcCoeff, uiWidth, uiHeight );
@@ -1061,9 +1070,18 @@
   piCoeff = pcCU->getCoeffY();
   pResi = m_ppcYuvResi[uiDepth]->getLumaAddr();
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+  Int QPoffset = pcCU->getQpOffsetForTextCU(uiAbsPartIdx, false);
+  m_pcTrQuant->setQPforQuant  ( pcCU->getQP(uiAbsPartIdx) + QPoffset, !pcCU->getSlice()->getDepth(), pcCU->getSlice()->getSliceType(), TEXT_LUMA );
+#else
   m_pcTrQuant->setQPforQuant( pcCU->getQP( uiAbsPartIdx ), !pcCU->getSlice()->getDepth(), pcCU->getSlice()->getSliceType(), TEXT_LUMA );
+#endif
   m_pcTrQuant->invRecurTransformNxN ( pcCU, 0, TEXT_LUMA, pResi, 0, m_ppcYuvResi[uiDepth]->getStride(), uiWidth, uiHeight, uiLumaTrMode, 0, piCoeff );
   
   // Cb and Cr
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+    m_pcTrQuant->setQPforQuant( pcCU->getQP( uiAbsPartIdx ) + QPoffset, !pcCU->getSlice()->getDepth(), pcCU->getSlice()->getSliceType(), TEXT_CHROMA );
+#else
   m_pcTrQuant->setQPforQuant( pcCU->getQP( uiAbsPartIdx ), !pcCU->getSlice()->getDepth(), pcCU->getSlice()->getSliceType(), TEXT_CHROMA );
+#endif
   
   uiWidth  >>= 1;
Index: branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecCu.h
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecCu.h	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecCu.h	(revision 12)
@@ -61,8 +61,8 @@
   TComYuv**           m_ppcYuvReco;       ///< array of prediction & reconstruction buffer
   TComYuv**           m_ppcYuvResPred;    ///< residual prediction buffer
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SKIP
   TComYuv**           m_ppcYuvAvail;      ///< array of available map buffer
 #endif
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
   TComYuv**           m_ppcYuvSynth;      ///< array of synth buffer
 #endif
Index: branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecEntropy.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 12)
@@ -430,4 +430,15 @@
   pcCU->setInterDirSubParts( puhInterDirNeighbours[uiMergeIndex], uiAbsPartIdx, uiPartIdx, uiDepth );
 
+#if POZNAN_EIVD_CALC_PRED_DATA
+  Int ref_idx0_EIVD,ref_idx1_EIVD;
+  TComMv cMv0_EIVD( 0, 0 ),cMv1_EIVD( 0, 0 );
+  if(uiMergeIndex==POZNAN_EIVD_MRG_CAND)
+  {	
+    pcCU->getCUMvField2nd( REF_PIC_LIST_0 )->setAllMvField( pcMvFieldNeighbours[ 2*uiMergeIndex ].getMv(), pcMvFieldNeighbours[ 2*uiMergeIndex ].getRefIdx(), eCUMode, uiAbsPartIdx, uiPartIdx, uiDepth );
+    pcCU->getCUMvField2nd( REF_PIC_LIST_1 )->setAllMvField( pcMvFieldNeighbours[ 2*uiMergeIndex + 1 ].getMv(), pcMvFieldNeighbours[ 2*uiMergeIndex + 1 ].getRefIdx(), eCUMode, uiAbsPartIdx, uiPartIdx, uiDepth );	
+    pcCU->getSlice()->getMP()->calcEIVDPredData(pcCU, uiAbsPartIdx, ref_idx0_EIVD, cMv0_EIVD, ref_idx1_EIVD, cMv1_EIVD);
+  }
+#endif
+
   TComMv cTmpMv( 0, 0 );
   if ( pcCU->getSlice()->getNumRefIdx( REF_PIC_LIST_0 ) > 0  ) //if ( ref. frame list0 has at least 1 entry )
@@ -436,4 +447,9 @@
     pcCU->setMVPNumSubParts( 0, REF_PIC_LIST_0, uiAbsPartIdx, uiPartIdx, uiDepth);
     pcCU->getCUMvField( REF_PIC_LIST_0 )->setAllMvd( cTmpMv, eCUMode, uiAbsPartIdx, uiPartIdx, uiDepth );
+#if POZNAN_EIVD_CALC_PRED_DATA
+    if(uiMergeIndex==POZNAN_EIVD_MRG_CAND) 
+       pcCU->getCUMvField( REF_PIC_LIST_0 )->setAllMvField( cMv0_EIVD, ref_idx0_EIVD, eCUMode, uiAbsPartIdx, uiPartIdx, uiDepth );
+    else
+#endif
     pcCU->getCUMvField( REF_PIC_LIST_0 )->setAllMvField( pcMvFieldNeighbours[ 2*uiMergeIndex ].getMv(), pcMvFieldNeighbours[ 2*uiMergeIndex ].getRefIdx(), eCUMode, uiAbsPartIdx, uiPartIdx, uiDepth );
 
@@ -444,4 +460,9 @@
     pcCU->setMVPNumSubParts( 0, REF_PIC_LIST_1, uiAbsPartIdx, uiPartIdx, uiDepth);
     pcCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvd( cTmpMv, eCUMode, uiAbsPartIdx, uiPartIdx, uiDepth );
+#if POZNAN_EIVD_CALC_PRED_DATA
+    if(uiMergeIndex==POZNAN_EIVD_MRG_CAND)
+       pcCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMv1_EIVD, ref_idx1_EIVD, eCUMode, uiAbsPartIdx, uiPartIdx, uiDepth );
+    else
+#endif
     pcCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( pcMvFieldNeighbours[ 2*uiMergeIndex + 1 ].getMv(), pcMvFieldNeighbours[ 2*uiMergeIndex + 1 ].getRefIdx(), eCUMode, uiAbsPartIdx, uiPartIdx, uiDepth );
   }
Index: branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecGop.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecGop.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecGop.cpp	(revision 12)
@@ -199,4 +199,14 @@
 #endif
 
+#if POZNAN_MP
+	if( uiStartCUAddr == 0 )
+    {
+#if POZNAN_MP_USE_DEPTH_MAP_GENERATION
+	  pcSlice->getMP()->setDepthMapGenerator(m_pcDepthMapGenerator);
+#endif
+      pcSlice->getMP()->pairMultiview(rpcPic);
+	}
+#endif
+
     // decode slice
     m_pcSliceDecoder->decompressSlice(pcBitstream, rpcPic);
Index: branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 12)
@@ -579,5 +579,5 @@
 
 
-#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI
+#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI || POZNAN_EIVD
 Void TDecSbac::parseMergeIndexMV( TComDataCU* pcCU, UInt& ruiMergeIndex, UInt uiAbsPartIdx, UInt uiDepth )
 {
@@ -585,4 +585,8 @@
   const Bool bMVIAvailable = pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE;
   const UInt uiMviMergePos = bMVIAvailable ? HHI_MPI_MERGE_POS : MRG_MAX_NUM_CANDS;
+#endif
+#if POZNAN_EIVD
+  const Bool bEIVDAvailable = pcCU->getSlice()->getMP()->isEIVDEnabled();
+  Bool bEIVDModifyMergeIdx = true;
 #endif
   //--- set number of candidates and availability ---
@@ -611,4 +615,32 @@
     }
   }
+
+#if POZNAN_EIVD
+  if(bEIVDAvailable)
+  {
+    UInt uiEIVDMergePos = POZNAN_EIVD_MERGE_POS;
+#if HHI_MPI
+	if(bMVIAvailable && uiEIVDMergePos>=uiMviMergePos) uiEIVDMergePos++;
+#endif
+	for( Int iIdx = MRG_MAX_NUM_CANDS-2; iIdx >= (Int)uiEIVDMergePos; iIdx-- )
+	{
+		Int iWrIdx = iIdx+1;
+#if HHI_MPI
+		if(bMVIAvailable) 
+		{
+			if(iIdx==(Int)uiMviMergePos) continue;
+			if(iWrIdx==(Int)uiMviMergePos) iWrIdx++;
+		}
+#endif
+		if(iWrIdx>=MRG_MAX_NUM_CANDS) continue;
+
+		abAvailable[ iWrIdx ] = abAvailable[ iIdx ];
+	}
+	abAvailable[ uiEIVDMergePos ] = ( pcCU->getNeighbourCandIdx( POZNAN_EIVD_MRG_CAND, uiAbsPartIdx ) == POZNAN_EIVD_MRG_CAND + 1 );
+	
+	uiNumCand = 0; for( UInt uiIdx = 0; uiIdx < MRG_MAX_NUM_CANDS; uiIdx++ ) if(abAvailable[ uiIdx ]) uiNumCand++;
+  }
+#endif
+
   AOF( uiNumCand > 1 );
 
@@ -665,4 +697,15 @@
   {
     pcCU->setTextureModeDepthSubParts( uiDepth, uiAbsPartIdx, uiDepth );
+#if POZNAN_EIVD
+	bEIVDModifyMergeIdx = false;
+#endif
+  }
+#endif
+
+#if POZNAN_EIVD
+  if(bEIVDAvailable && bEIVDModifyMergeIdx)
+  {
+	if(ruiMergeIndex==POZNAN_EIVD_MERGE_POS) ruiMergeIndex = POZNAN_EIVD_MRG_CAND;
+	else if(ruiMergeIndex>POZNAN_EIVD_MERGE_POS) ruiMergeIndex--;
   }
 #endif
@@ -694,5 +737,5 @@
 Void TDecSbac::parseMergeIndex ( TComDataCU* pcCU, UInt& ruiMergeIndex, UInt uiAbsPartIdx, UInt uiDepth )
 {
-#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI
+#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI || POZNAN_EIVD
   if(
 #if HHI_INTER_VIEW_MOTION_PRED
@@ -701,4 +744,7 @@
 #if HHI_MPI
       ( pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE && pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_2Nx2N ) ||
+#endif
+#if	POZNAN_EIVD  
+	  ( pcCU->getSlice()->getMP()->isEIVDEnabled() ) ||
 #endif
       0
Index: branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecSbac.h	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecSbac.h	(revision 12)
@@ -144,5 +144,5 @@
   Void parseMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt uiPUIdx );
   Void parseMergeIndex    ( TComDataCU* pcCU, UInt& ruiMergeIndex, UInt uiAbsPartIdx, UInt uiDepth );
-#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI
+#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI || POZNAN_EIVD
   Void parseMergeIndexMV  ( TComDataCU* pcCU, UInt& ruiMergeIndex, UInt uiAbsPartIdx, UInt uiDepth );
 #endif
Index: branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecSlice.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 12)
@@ -98,4 +98,12 @@
     g_bJustDoIt = g_bEncDecTraceEnable;
 #endif
+
+	// JK {
+	DTRACE_CABAC_V( g_nSymbolCounter++ );
+	DTRACE_CABAC_T( "\tCU: " );
+	DTRACE_CABAC_V( iCUAddr );
+	DTRACE_CABAC_T( "\n" );
+	// JK }
+
     m_pcCuDecoder->decodeCU     ( pcCU, uiIsLast );
     m_pcCuDecoder->decompressCU ( pcCU );
Index: branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecTop.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecTop.cpp	(revision 12)
@@ -53,5 +53,5 @@
     m_aaiCodedScale       [ uiId ] = new Int [ MAX_NUMBER_VIEWS ];
   }
-#if POZNAN_SYNTH
+#if POZNAN_CU_SKIP || POZNAN_CU_SYNTH || (POZNAN_MP && !POZNAN_MP_USE_DEPTH_MAP_GENERATION)
   xCreateLUTs   ( (UInt)MAX_NUMBER_VIEWS, (UInt)MAX_NUMBER_VIEWS,  m_adBaseViewShiftLUT,  m_aiBaseViewShiftLUT);
 
@@ -73,5 +73,5 @@
   delete [] m_aiViewReceived;
 
-#if POZNAN_SYNTH
+#if POZNAN_CU_SKIP || POZNAN_CU_SYNTH || (POZNAN_MP && !POZNAN_MP_USE_DEPTH_MAP_GENERATION)
   xDeleteArray( m_adBaseViewShiftLUT,        MAX_NUMBER_VIEWS, MAX_NUMBER_VIEWS,  2 );
   xDeleteArray( m_aiBaseViewShiftLUT,        MAX_NUMBER_VIEWS, MAX_NUMBER_VIEWS,  2 );
@@ -91,5 +91,5 @@
 }
 
-#if POZNAN_SYNTH
+#if POZNAN_CU_SKIP || POZNAN_CU_SYNTH || (POZNAN_MP && !POZNAN_MP_USE_DEPTH_MAP_GENERATION)
 /*
 Void
@@ -294,5 +294,5 @@
         m_aaiCodedScale [ uiViewId ][ uiBaseId ]  = pcSlice->getInvCodedScale () [ uiBaseId ];
         m_aaiCodedOffset[ uiViewId ][ uiBaseId ]  = pcSlice->getInvCodedOffset() [ uiBaseId ];
-#if POZNAN_SYNTH
+#if POZNAN_CU_SKIP || POZNAN_CU_SYNTH || (POZNAN_MP && !POZNAN_MP_USE_DEPTH_MAP_GENERATION)
         xInitLUTs(uiBaseId,uiViewId,m_aaiCodedScale [ uiBaseId ][ uiViewId ],m_aaiCodedOffset[ uiBaseId ][ uiViewId ],m_adBaseViewShiftLUT,m_aiBaseViewShiftLUT);
         xInitLUTs(uiViewId,uiBaseId,m_aaiCodedScale [ uiViewId ][ uiBaseId ],m_aaiCodedOffset[ uiViewId ][ uiBaseId ],m_adBaseViewShiftLUT,m_aiBaseViewShiftLUT);
@@ -305,5 +305,5 @@
         m_aaiCodedScale [ uiViewId ][ uiBaseId ]  = pcSlice->getSPS()->getInvCodedScale () [ uiBaseId ];
         m_aaiCodedOffset[ uiViewId ][ uiBaseId ]  = pcSlice->getSPS()->getInvCodedOffset() [ uiBaseId ];
-#if POZNAN_SYNTH
+#if POZNAN_CU_SKIP || POZNAN_CU_SYNTH || (POZNAN_MP && !POZNAN_MP_USE_DEPTH_MAP_GENERATION)
         xInitLUTs(uiBaseId,uiViewId,m_aaiCodedScale [ uiBaseId ][ uiViewId ],m_aaiCodedOffset[ uiBaseId ][ uiViewId ],m_adBaseViewShiftLUT,m_aiBaseViewShiftLUT);
         xInitLUTs(uiViewId,uiBaseId,m_aaiCodedScale [ uiViewId ][ uiBaseId ],m_aaiCodedOffset[ uiViewId ][ uiBaseId ],m_adBaseViewShiftLUT,m_aiBaseViewShiftLUT);
@@ -323,5 +323,5 @@
         m_aaiCodedScale [ uiViewId ][ uiBaseId ]  = pcSlice->getInvCodedScale () [ uiBaseId ];
         m_aaiCodedOffset[ uiViewId ][ uiBaseId ]  = pcSlice->getInvCodedOffset() [ uiBaseId ];
-#if POZNAN_SYNTH
+#if POZNAN_CU_SKIP || POZNAN_CU_SYNTH || (POZNAN_MP && !POZNAN_MP_USE_DEPTH_MAP_GENERATION)
         xInitLUTs(uiBaseId,uiViewId,m_aaiCodedScale [ uiBaseId ][ uiViewId ],m_aaiCodedOffset[ uiBaseId ][ uiViewId ],m_adBaseViewShiftLUT,m_aiBaseViewShiftLUT);
         xInitLUTs(uiViewId,uiBaseId,m_aaiCodedScale [ uiViewId ][ uiBaseId ],m_aaiCodedOffset[ uiViewId ][ uiBaseId ],m_adBaseViewShiftLUT,m_aiBaseViewShiftLUT);
@@ -411,4 +411,7 @@
   m_bFirstSliceInSequence   = true;
   m_pcCamParsCollector = 0;
+#if POZNAN_MP
+  m_pcMP = NULL;
+#endif
 }
 
@@ -441,4 +444,8 @@
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   m_cResidualGenerator.destroy();
+#endif
+
+#if POZNAN_MP
+  m_pcMP = NULL;
 #endif
 }
@@ -478,4 +485,8 @@
   m_cResidualGenerator.init( &m_cTrQuant, &m_cDepthMapGenerator );
 #endif
+
+#if POZNAN_MP
+  m_pcMP = pcTAppDecTop->getMP();
+#endif
 }
 
@@ -604,9 +615,12 @@
     pcPic->removeUsedPelsMapBuffer();
 #endif
-#if POZNAN_AVAIL_MAP
+#if POZNAN_CU_SYNTH || POZNAN_CU_SKIP
     pcPic->removeAvailabilityBuffer();
 #endif
-#if POZNAN_SYNTH_VIEW
+#if POZNAN_CU_SYNTH
     pcPic->removeSynthesisBuffer();
+#endif
+#if POZNAN_TEXTURE_TU_DELTA_QP_ACCORDING_TO_DEPTH
+    pcPic->removeSynthesisDepthBuffer();
 #endif
   }
@@ -696,7 +710,16 @@
       else
       {
+#if POZNAN_NONLINEAR_DEPTH
+        // For texture complete depth power information. Depth power is sended, for example, for base view depth map and it should be available prior non-base texture decoding
+        if(!cTempSPS.isDepth() && cTempSPS.getViewId())
+        {
+          Float fDepthPower = getDecTop()->getPicFromView( 0, pcPic->getPOC(), true )->getSPS()->getDepthPower();
+          cTempSPS.setDepthPower(fDepthPower);
+        }
+#endif
         cComSPS = cTempSPS;
         return false;
       }
+      
 
       // create ALF temporary buffer
@@ -710,4 +733,12 @@
       }
       m_uiValidPS |= 1;
+
+#if POZNAN_MP
+#if POZNAN_MP_USE_DEPTH_MAP_GENERATION
+      m_pcMP->init( m_cSPS.getHeight(), m_cSPS.getWidth() );
+#else
+      m_pcMP->init( m_cSPS.getHeight(), m_cSPS.getWidth(), m_pcCamParsCollector->getBaseViewShiftLUTI());
+#endif 
+#endif 
 
       return false;
@@ -820,4 +851,8 @@
       m_apcSlicePilot = pcPic->getPicSym()->getSlice(m_uiSliceIdx);
       pcPic->getPicSym()->setSlice(pcSlice, m_uiSliceIdx);
+
+#if POZNAN_MP
+	  pcSlice->setMP(m_pcMP);
+#endif
 
       if (bNextSlice)
@@ -875,15 +910,28 @@
 #endif
 
-#if POZNAN_SYNTH
-      if( m_pcCamParsCollector)
+#if POZNAN_CU_SKIP || POZNAN_CU_SYNTH
+      if( m_pcCamParsCollector )
       {
         m_pcCamParsCollector->setSlice( pcSlice );
       }
       //if(!getIsDepth())
-      getDecTop()->storeSynthPicsInBuffer(pcSlice->getViewIdx(),pcSlice->getSPS()->getViewOrderIdx(),pcSlice->getPOC(),getIsDepth());
+        getDecTop()->storeSynthPicsInBuffer(pcSlice->getViewIdx(),pcSlice->getSPS()->getViewOrderIdx(),pcSlice->getPOC(),getIsDepth());
+#endif
+
+#if POZNAN_MP 
+	std::vector<TComPic*> apcSpatDataRefPics = getDecTop()->getSpatialRefPics( pcPic->getViewIdx(), pcSlice->getPOC(), m_cSPS.isDepth() );
+	pcSlice->getMP()->setRefPicsList(&apcSpatDataRefPics);  
+#if !POZNAN_MP_USE_DEPTH_MAP_GENERATION
+	std::vector<TComPic*> apcSpatDepthRefPics = getDecTop()->getSpatialRefPics( pcPic->getViewIdx(), pcSlice->getPOC(), true );
+	pcSlice->getMP()->setDepthRefPicsList(&apcSpatDepthRefPics);
+#endif
 #endif
 
       //  Decode a picture
       m_cGopDecoder.decompressGop ( bEos, pcBitstream, pcPic, false );
+
+#if POZNAN_MP
+	  pcSlice->getMP()->disable();
+#endif
 
       if( m_pcCamParsCollector )
Index: branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecTop.h	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibDecoder/TDecTop.h	(revision 12)
@@ -55,4 +55,8 @@
 #include "TDecCAVLC.h"
 
+#if POZNAN_MP
+#include "../TLibCommon/TComMP.h"
+#endif
+
 // ====================================================================================================================
 // Class definition
@@ -71,5 +75,5 @@
   Void  uninit      ();
   Void  setSlice    ( TComSlice* pcSlice );
-#if POZNAN_SYNTH
+#if POZNAN_CU_SKIP || (POZNAN_MP && !POZNAN_MP_USE_DEPTH_MAP_GENERATION)
   Double****          getBaseViewShiftLUTD      ()  { return m_adBaseViewShiftLUT;   }
   Int****             getBaseViewShiftLUTI      ()  { return m_aiBaseViewShiftLUT;   }
@@ -99,5 +103,5 @@
   UInt    m_uiMaxViewId;
 
-#if POZNAN_SYNTH
+#if POZNAN_CU_SKIP || POZNAN_CU_SYNTH || (POZNAN_MP && !POZNAN_MP_USE_DEPTH_MAP_GENERATION)
 
   UInt    m_uiBitDepthForLUT;
@@ -118,5 +122,5 @@
 };
 
-#if POZNAN_SYNTH
+#if POZNAN_CU_SKIP || POZNAN_CU_SYNTH || (POZNAN_MP && !POZNAN_MP_USE_DEPTH_MAP_GENERATION)
   template <class T>
 Void CamParsCollector::xDeleteArray( T*& rpt, UInt uiSize1, UInt uiSize2, UInt uiSize3 )
@@ -223,4 +227,8 @@
 #endif
 
+#if POZNAN_MP
+  TComMP*				  m_pcMP;
+#endif
+
   Bool                    m_bIsDepth;
   Int                     m_iViewIdx;
Index: branches/0.2-poznan-univ/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 12)
@@ -341,4 +341,16 @@
       xWriteFlag( pcSPS->getUseMVI() ? 1 : 0 );
 #endif
+#if POZNAN_NONLINEAR_DEPTH
+      // Depth power coefficient
+#if POZNAN_NONLINEAR_DEPTH_SEND_AS_BYTE
+      UInt  uiCode = quantizeDepthPower(pcSPS->getDepthPower());  
+      xWriteCode(uiCode, 8); 
+#else
+      float fCode  = pcSPS->getDepthPower();
+      UInt  uiCode = *((UInt*)&fCode);
+      //uiCode &= ~0x80000000;
+      xWriteCode(uiCode, sizeof(float)*8); // we do not send sign?;
+#endif
+#endif
     }
     else
@@ -353,7 +365,6 @@
         for( UInt uiId = 0; uiId < pcSPS->getViewId(); uiId++ )
         {
-          //printf("From ViewID %d To ViewID: %d\n",pcSPS->getViewId(),uiId);
-          xWriteSvlc( pcSPS->getCodedScale    ()[ uiId ] ); //printf("SPS Scale: %d\n",pcSPS->getCodedScale    ()[ uiId ]);
-          xWriteSvlc( pcSPS->getCodedOffset   ()[ uiId ] ); //printf("SPS Offset: %d\n", pcSPS->getCodedOffset   ()[ uiId ]);
+          xWriteSvlc( pcSPS->getCodedScale    ()[ uiId ] );
+          xWriteSvlc( pcSPS->getCodedOffset   ()[ uiId ] );
           xWriteSvlc( pcSPS->getInvCodedScale ()[ uiId ] + pcSPS->getCodedScale ()[ uiId ] );
           xWriteSvlc( pcSPS->getInvCodedOffset()[ uiId ] + pcSPS->getCodedOffset()[ uiId ] );
@@ -532,7 +543,6 @@
       for( UInt uiId = 0; uiId < pcSlice->getSPS()->getViewId(); uiId++ )
       {
-        printf("From ViewID %d To ViewID: %d\n",pcSlice->getSPS()->getViewId(),uiId);
-        xWriteSvlc( pcSlice->getCodedScale    ()[ uiId ] ); printf("Slice Scale: %d\n",pcSlice->getCodedScale    ()[ uiId ]);
-        xWriteSvlc( pcSlice->getCodedOffset   ()[ uiId ] ); printf("Slice Offset: %d\n", pcSlice->getCodedOffset   ()[ uiId ]);
+        xWriteSvlc( pcSlice->getCodedScale    ()[ uiId ] );
+        xWriteSvlc( pcSlice->getCodedOffset   ()[ uiId ] );
         xWriteSvlc( pcSlice->getInvCodedScale ()[ uiId ] + pcSlice->getCodedScale ()[ uiId ] );
         xWriteSvlc( pcSlice->getInvCodedOffset()[ uiId ] + pcSlice->getCodedOffset()[ uiId ] );
@@ -729,5 +739,5 @@
 
 
-#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI
+#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI || POZNAN_EIVD
 Void 
 TEncCavlc::codeMergeIndexMV( TComDataCU* pcCU, UInt uiAbsPartIdx )
@@ -735,4 +745,14 @@
   UInt uiNumCand  = 0;
   UInt uiMergeIdx = pcCU->getMergeIndex( uiAbsPartIdx );
+
+#if POZNAN_EIVD
+  UInt uiModIdx;
+  const Bool bEIVDAvailable = pcCU->getSlice()->getMP()->isEIVDEnabled();
+  if(bEIVDAvailable)
+  {	  
+	  if(uiMergeIdx==POZNAN_EIVD_MRG_CAND) uiMergeIdx = POZNAN_EIVD_MERGE_POS;
+	  else if(uiMergeIdx>=POZNAN_EIVD_MERGE_POS) uiMergeIdx++;
+  }
+#endif
 #if HHI_MPI
   const Bool bMVIAvailable = pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE;
@@ -752,4 +772,21 @@
     if( uiIdx < uiMviMergePos )
     {
+#if POZNAN_EIVD
+	  if(bEIVDAvailable)
+	  {
+		  if(uiIdx==POZNAN_EIVD_MERGE_POS) uiModIdx = POZNAN_EIVD_MRG_CAND;
+		  else if(uiIdx>POZNAN_EIVD_MERGE_POS) uiModIdx = uiIdx--;
+		  else uiModIdx = uiIdx;
+	  }
+	  else uiModIdx = uiIdx;
+	  if( pcCU->getNeighbourCandIdx( uiModIdx, uiAbsPartIdx ) == uiModIdx + 1 )
+	  {
+        uiNumCand++;
+      }
+      else if( uiIdx < uiMergeIdx )
+      {
+        uiUnaryIdx--;
+      }
+#else
       if( pcCU->getNeighbourCandIdx( uiIdx, uiAbsPartIdx ) == uiIdx + 1 )
       {
@@ -760,7 +797,25 @@
         uiUnaryIdx--;
       }
+#endif
     }
     else if( uiIdx > uiMviMergePos )
     {
+#if POZNAN_EIVD
+	  if(bEIVDAvailable)
+	  {
+		  if(uiIdx==POZNAN_EIVD_MERGE_POS) uiModIdx = POZNAN_EIVD_MRG_CAND;
+		  else if(uiIdx>POZNAN_EIVD_MERGE_POS) uiModIdx = uiIdx--;
+		  else uiModIdx = uiIdx;
+	  }
+	  else uiModIdx = uiIdx;
+	  if( pcCU->getNeighbourCandIdx( uiModIdx-1, uiAbsPartIdx ) == uiModIdx )
+	  {
+        uiNumCand++;
+      }
+      else if( uiIdx < uiMergeIdx )
+      {
+        uiUnaryIdx--;
+      }
+#else
       if( pcCU->getNeighbourCandIdx( uiIdx - 1, uiAbsPartIdx ) == uiIdx )
       {
@@ -771,4 +826,5 @@
         uiUnaryIdx--;
       }
+#endif
     }
   }
@@ -777,4 +833,21 @@
   for( UInt uiIdx = 0; uiIdx < MRG_MAX_NUM_CANDS; uiIdx++ )
   {
+#if POZNAN_EIVD
+	if(bEIVDAvailable)
+	{
+	  if(uiIdx==POZNAN_EIVD_MERGE_POS) uiModIdx = POZNAN_EIVD_MRG_CAND;
+	  else if(uiIdx>POZNAN_EIVD_MERGE_POS) uiModIdx = uiIdx--;
+	  else uiModIdx = uiIdx;
+	}
+	else uiModIdx = uiIdx;
+	if( pcCU->getNeighbourCandIdx( uiModIdx, uiAbsPartIdx ) == uiModIdx + 1 )
+	{
+	  uiNumCand++;
+	}
+	else if( uiIdx < uiMergeIdx )
+	{
+	  uiUnaryIdx--;
+	}
+#else
     if( pcCU->getNeighbourCandIdx( uiIdx, uiAbsPartIdx ) == uiIdx + 1 )
     {
@@ -785,4 +858,5 @@
       uiUnaryIdx--;
     }
+#endif
   }
 #endif
@@ -808,13 +882,17 @@
 Void TEncCavlc::codeMergeIndex    ( TComDataCU* pcCU, UInt uiAbsPartIdx )
 {
-#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI
-#if HHI_INTER_VIEW_MOTION_PRED && HHI_MPI
-  if( ( pcCU->getSlice()->getSPS()->getViewId() > 0 && ( pcCU->getSlice()->getSPS()->getMultiviewMvPredMode() & PDM_USE_FOR_MERGE ) == PDM_USE_FOR_MERGE ) ||
-      ( pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE && pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_2Nx2N ) )
-#elif HHI_MPI
-  if( pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE && pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_2Nx2N )
-#else
-  if( pcCU->getSlice()->getSPS()->getViewId() > 0 && ( pcCU->getSlice()->getSPS()->getMultiviewMvPredMode() & PDM_USE_FOR_MERGE ) == PDM_USE_FOR_MERGE )
-#endif
+#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI || POZNAN_EIVD
+  if( 
+#if HHI_INTER_VIEW_MOTION_PRED
+	  ( pcCU->getSlice()->getSPS()->getViewId() > 0 && ( pcCU->getSlice()->getSPS()->getMultiviewMvPredMode() & PDM_USE_FOR_MERGE ) == PDM_USE_FOR_MERGE ) ||
+#endif
+#if HHI_MPI
+	  ( pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE && pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_2Nx2N ) ||
+#endif
+#if	POZNAN_EIVD  
+	  ( pcCU->getSlice()->getMP()->isEIVDEnabled() ) ||
+#endif
+	  0
+    )
   {
     codeMergeIndexMV( pcCU, uiAbsPartIdx );
Index: branches/0.2-poznan-univ/source/Lib/TLibEncoder/TEncCavlc.h
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibEncoder/TEncCavlc.h	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibEncoder/TEncCavlc.h	(revision 12)
@@ -228,5 +228,5 @@
   Void codeMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx );
   Void codeMergeIndex    ( TComDataCU* pcCU, UInt uiAbsPartIdx );
-#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI
+#if HHI_INTER_VIEW_MOTION_PRED || HHI_MPI || POZNAN_EIVD
   Void codeMergeIndexMV  ( TComDataCU* pcCU, UInt uiAbsPartIdx );
 #endif
Index: branches/0.2-poznan-univ/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- branches/0.2-poznan-univ/source/Lib/TLibEncoder/TEncCfg.h	(revision 11)
+++ branches/0.2-poznan-univ/source/Lib/TLibEncoder/TEncCfg.h	(revision 12)
@@ -217,4 +217,13 @@
 #endif
 
+#if POZNAN_TEXTURE_TU_DELTA_QP_PARAM_IN_CFG_FOR_ENC 
+  Double      m_dTextureCuDeltaQpOffset;
+  Double      m_dTextureCuDeltaQpMul;
+  Int         m_iTextureCuDeltaQpTopBottomRow; 
+#endif
+#if POZNAN_NONLINEAR_DEPTH
+  Float 	m_fDepthPower;
+#endif
+
 public:
   TEncCfg()          {}
@@ -226,4 +235,9 @@
   Void      setSourceHeight                 ( Int   i )      { m_iSourceHeight = i; }
   Void      setFrameToBeEncoded             ( Int   i )      { m_iFrameToBeEncoded = i; }
+
+#if POZNAN_STAT_JK
+  FILE* m_pcStatFile;
+  Void setStatFile(FILE* a) {m_pcStatFile = a;}
+#endif
 
   //====== Coding Structure ========
@@ -306,4 +320,11 @@
   Void      setAllowNegDist                 ( Bool b  )     { m_bAllowNegDist     = b; };
 #endif
+#endif
+
+#if POZNAN_NONLINEAR_DEPTH
+  inline Float   getDepthPower()               { return m_fDepthPower; }
+  inline Void    setDepthPower(Float p)        { m_fDepthPower = p; }
+#else
+ inline Float    getDepthPower()               { return 1.0f; }
 #endif
 
